//***** *****//
#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>

//***** *****//
char chislo[11] = {0b00111111, 0b00000110, 0b01011011, 0b01001111, 0b01100110,\
0b01101101, 0b01111101, 0b00000111, 0b01111111, 0b01101111, 0b11111111};

char vremya[29] = {0, 0, 0, 0,\
	0, 0, 0, 0,\
	0, 1, 0, 1,\
	2, 0, 0, 0,\
	0, 0, 0, 0,\
	0, 0, 0, 0,\
	11, 11, 11, 11,\
0};

char zaderjka = 0;
char indikator = 0;

char flag_knopki_4 = 0;
int proverka_knopki_4 = 0;

char flag_0[5] = {0, 0, 0, 0, 0};
char proverka[5] = {0, 0, 0, 0, 0};

char flag_sec = 0;

char flag_bud_on_off = 0;
char flag_bud_2 = 0;
char flag_bud_1 = 0;
int bud_2 = 0;
char bud_1 = 0;

char flag_dinamik = 0;

char flag_prosmotr = 0;

char flag_secundomera = 0;
char i = 0;
int q = 0;


int den = 1;
int god = 2000;
char flag_visokosnogo_goda = 1;
char mesyac = 1;

char flag_timer = 0;
char vremya_timer = 0;
char flag_signala = 0;
char vremya_signala = 0;
char flag_sec_timer = 0;

char n = 24;

char k = 0;
unsigned int adc = 0;
int zaryad = 0;

//*****  *****//
ISR (ADC_vect)
{
	ADCSRA |= (1<<ADSC);
	k++;
	adc = adc + ADC;
	if (k == 50)
	{
		k = 0;
		zaryad = adc / 50;
		adc = 0;
	}
}

//*****     0*****//
ISR (TIMER0_OVF_vect)
{
	TCNT0 = 127;
	if (flag_dinamik == 1)
	{
		PORTB ^= 0b00010000;
	}
	else
	{
		PORTB &= 0b11101111;
	}
}

//*****     1(A)*****//
ISR (TIMER1_COMPA_vect)
{
	PORTB &= 0b11110000;
}

//*****     1(B)*****//
ISR (TIMER1_COMPB_vect)
{
	TCNT1 = 0;
	/*****_*****/
	zaderjka++;
	if (zaderjka == 6)
	{
		zaderjka = 0;
		indikator++;
	}
	if (indikator == 4)
	{
		indikator = 0;
	}
	switch(indikator)
	{
		case 3:PORTB = (PORTB&0b11110000)|0b00001000;PORTD = ~chislo[vremya[3+n]];break;
		case 2:PORTB = (PORTB&0b11110000)|0b00000100;PORTD = ~chislo[vremya[2+n]];
		if (n == 20) PORTD &= 0b01111111;break;
		case 1:PORTB = (PORTB&0b11110000)|0b00000010;PORTD = ~chislo[vremya[1+n]];
		if ((flag_sec == 1)&&(n == 0)) PORTD &= 0b01111111;
		if (n == 4) PORTD &= 0b01111111;
		if ((n == 16)&&(flag_sec_timer == 1)) PORTD &= 0b01111111;break;
		case 0:PORTB = (PORTB&0b11110000)|0b00000001;PORTD = ~chislo[vremya[0+n]];
		if (n == 8) PORTD &= 0b01111111;if (n == 16) PORTD &= 0b01111111;break;
	}
	/*****__1_*****/
	if (flag_0[0] == 1)
	{
		proverka[0]++;
	}
	/*****__2_*****/
	if (flag_0[1] == 1)
	{
		proverka[1]++;
	}
	/*****__3_*****/
	if (flag_0[2] == 1)
	{
		proverka[2]++;
	}
	/*****__4_*****/
	if (flag_0[3] == 1)
	{
		proverka[3]++;
	}
	/*****__4__ *****/
	if (flag_knopki_4 == 1)
	{
		proverka_knopki_4++;
	}
	/*****__5_*****/
	if (flag_0[4] == 1)
	{
		proverka[4]++;
	}
}

//*****     2*****//
ISR (TIMER2_OVF_vect)
{
	flag_dinamik = 0;
	//**********//
	flag_sec = 1;
	vremya[28]++;
	if (vremya[28] == 60)
	{
		vremya[28] = 0;
		vremya[3]++;
	}
	if (vremya[3] == 10)
	{
		vremya[3] = 0;
		vremya[2]++;
	}
	if (vremya[2] == 6)
	{
		vremya[2] = 0;
		vremya[1]++;
	}
	if (vremya[1] == 10)
	{
		vremya[1] = 0;
		vremya[0]++;
	}
	if ((vremya[1]==4)&&(vremya[0]==2))
	{
		vremya[1] = 0;
		vremya[0] = 0;
	}
	
	//*****_*****//
	if (flag_bud_1 == 1)
	{
		bud_1++;
	}
	if (bud_1 == 60)
	{
		bud_1 = 0;
		flag_bud_1 = 0;
		flag_bud_on_off = 0;
	}
	if (flag_bud_2)
	{
		bud_2++;
	}
	if (bud_2 == 1260)
	{
		bud_2 = 0;
		flag_bud_2 = 0;
		flag_bud_on_off = 0;
	}
	
	//*****_*****//
	if ((vremya[0] == 0)&&(vremya[1] == 0)&&(vremya[2] == 0)&&\
	(vremya[3] == 0)&&(vremya[28] == 0))
	{
		den++;
	}
	
	//*****_*****//
	if (flag_timer == 1)
	{
		vremya_timer--;
	}
	if ((vremya[16] == 0)&&(vremya[17] == 0)&&(vremya[18] == 0)&&(vremya[19] == 0)&&(flag_timer == 1)&&\
	(vremya_timer == 0))
	{
		flag_timer = 0;
		vremya_timer = 0;
		flag_signala = 1;
	}
	if (vremya_timer == 255)
	{
		vremya[19]--;
		vremya_timer = 59;
	}
	if (vremya[19] == 255)
	{
		vremya[18]--;
		vremya[19] = 9;
	}
	if (vremya[18] == 255)
	{
		vremya[17]--;
		vremya[18] = 5;
	}
	if (vremya[17] == 255)
	{
		vremya[16]--;
		vremya[17] = 9;
	}
	if (flag_signala == 1)
	{
		vremya_signala++;
	}
	if (vremya_signala == 60)
	{
		vremya_signala = 0;
		flag_signala = 0;
	}
	flag_sec_timer = 1;
}

//*****     2*****//
ISR(TIMER2_COMP_vect)
{
	flag_sec = 0;
	if (flag_timer == 1)
	{
		flag_sec_timer = 0;
	}
	if (bud_1 > 0)
	{
		flag_dinamik = 1;
	}
	if (((bud_2 > 0)&&(bud_2 < 60))|((bud_2 > 600)&&(bud_2 < 660))|((bud_2 > 1200)&&(bud_2 < 1260)))
	{
		flag_dinamik = 1;
	}
	if (flag_signala == 1)
	{
		flag_dinamik = 1;
	}	
}

//***** *****//
int main(void)
{
	/*****_*****/
	DDRD = 0b11111111;
	PORTD = 0;
	DDRB = 0b00111111;
	PORTB = 0b00001111;
	DDRC = 0;
	PORTC = 0b01011111;
	/*****__*****/
	ACSR |= 0b10000000;
	/*****_*****/
	ADCSRA |= (1<<ADEN) |(1<<ADIE) |(1<<ADPS0) |(0<<ADPS1) |(1<<ADPS2);
	ADMUX |= (1<<REFS1) |(1<<REFS0) |(0<<MUX3) |(1<<MUX2) |(0<<MUX1) |(1<<MUX0);
	ADCSRA |= (1<<ADSC);
	/*****_0*****/
	TCNT0 = 127;
	TCCR0 |= (1<<1);
	TIMSK |= (1<<0);
	/*****_1*****/
	TCCR1B |= (1<<1);
	OCR1B = 256;
	OCR1A = 64;
	TIMSK |= (1<<3);
	/*****_2*****/
	asm("cli");
	ASSR |= 0b00001000; //__
	while (ASSR != 0b00001000)
	{
		asm("nop");
	}
	TCCR2 |= 0b00000101;
	OCR2 = 127;
	TIMSK |= 0b11000000;
	TIFR = 0;
	sei();//__
	//***** *****//
	while(1)
	{
		
		if (zaryad > 570)
		{
			knopka0();
			knopka1();
			knopka2();
			knopka3_1();
			knopka4();
			budilnik();
			kalendar();
			secyndomer();
			TIMSK |= 0b10001001;
		}
		else
		{
			kalendar();
			flag_knopki_4 = 0;
			proverka_knopki_4 = 0;
			
			flag_0[0] = 0;flag_0[1] = 0;flag_0[2] = 0;flag_0[3] = 0;flag_0[4] = 0;
			proverka[0] = 0;proverka[1] = 0;proverka[2] = 0;proverka[3] = 0;proverka[4] = 0;
			
			flag_bud_on_off = 0;
			flag_bud_2 = 0;
			flag_bud_1 = 0;
			bud_2 = 0;
			bud_1 = 0;
			
			vremya[16] = 0;vremya[17] = 0;vremya[18] = 0;vremya[19] = 0;
			vremya[20] = 0;vremya[21] = 0;vremya[22] = 0;vremya[23] = 0;
			
			flag_dinamik = 0;

			flag_prosmotr = 0;
			
			flag_secundomera = 0;
			q = 0;

			flag_timer = 0;
			vremya_timer = 0;
			flag_signala = 0;
			vremya_signala = 0;
			flag_sec_timer = 0;
			if (~PINC & 0b00000010)
			{
				TIMSK |= 0b10011000;
				n = 0;
			}
			else
			{
				n = 24;
				TIMSK &= 0b01000000;
				PORTB &= 0b11000000;
				PORTD &= 0b00000000;
			}
		}
	}
}

/***** *****/
secyndomer()
{
	if ((vremya[20] == 9)&&(vremya[21] == 9)&&(vremya[22] == 9)&&(vremya[23] == 9))
	{
		flag_secundomera = 0;
		q = 0;
	}
	if ((flag_secundomera == 1)&&(i != TCNT2))
	{
		i = TCNT2;
		q++;
		vremya[23] = q/26;
		if (q == 256)
		{
			vremya[22]++;
			q = 0;
		}
	}
	if (flag_secundomera == 0)
	{
		i = 255;
	}
	if (vremya[22] == 10)
	{
		vremya[22] = 0;
		vremya[21]++;
	}
	if (vremya[21] == 10)
	{
		vremya[21] = 0;
		vremya[20]++;
	}
	if ((vremya[20] == 9)&&(vremya[21] == 9)&&(vremya[22] == 9)&&(vremya[23] == 9))
	{
		flag_secundomera = 0;
		q = 0;
	}		
}

/***** 1 -  *****/
knopka0()
{
	asm("cli");
	if (proverka[0] > 39)
	{
		if (PINC&0b00010000)
		{
			flag_0[0] = 1;
		}
		else
		{
			flag_0[0] = 0;
			proverka[0] = 40;
		}
		if (proverka[0] > 79)
		{
			if (!(n == 24))
			{
				TIMSK ^= 0b00010000;
			}
			flag_0[0] = 0;
			proverka[0] = 0;
		}
	}
	else
	{
		if (~PINC&0b00010000)
		{
			flag_0[0] = 1;
		}
		else
		{
			flag_0[0] = 0;
			proverka[0] = 0;
		}
	}
	asm("sei");
}

/***** 2 - +1 *****/
knopka1()
{
	asm("cli");
	if (proverka[1] > 39)
	{
		if (PINC&0b00001000)
		{
			flag_0[1] = 1;
		}
		else
		{
			flag_0[1] = 0;
			proverka[1] = 40;
		}
		if (proverka[1] > 79)
		{
			switch(n)
			{
				case 0:
				if (flag_prosmotr == 0)
				{
					vremya[1]++;
					if (vremya[1] == 10)
					{
						vremya[1] = 0;
						vremya[0]++;
					}
					if ((vremya[1]==4)&&(vremya[0]==2))
					{
						vremya[1] = 0;
						vremya[0] = 0;
					}
				}
				break;
				case 4:
				vremya[5]++;
				if (vremya[5] == 10)
				{
					vremya[5] = 0;
					vremya[4]++;
				}
				if ((vremya[5]==4)&&(vremya[4]==2))
				{
					vremya[5] = 0;
					vremya[4] = 0;
				}
				break;
				case 8:
				switch (mesyac)
				{
					case 1:den++;if (den == 32) den = 1;break;
					case 2:den++;if (den == 60 + flag_visokosnogo_goda) den = 32;break;
					case 3:den++;if (den == 91 + flag_visokosnogo_goda) den = 60 + flag_visokosnogo_goda;break;
					case 4:den++;if (den == 121 + flag_visokosnogo_goda) den = 91 + flag_visokosnogo_goda;break;
					case 5:den++;if (den == 152 + flag_visokosnogo_goda) den = 121 + flag_visokosnogo_goda;break;
					case 6:den++;if (den == 182 + flag_visokosnogo_goda) den = 152 + flag_visokosnogo_goda;break;
					case 7:den++;if (den == 213 + flag_visokosnogo_goda) den = 182 + flag_visokosnogo_goda;break;
					case 8:den++;if (den == 244 + flag_visokosnogo_goda) den = 213 + flag_visokosnogo_goda;break;
					case 9:den++;if (den == 274 + flag_visokosnogo_goda) den = 244 + flag_visokosnogo_goda;break;
					case 10:den++;if (den == 305 + flag_visokosnogo_goda) den = 274 + flag_visokosnogo_goda;break;
					case 11:den++;if (den == 335 + flag_visokosnogo_goda) den = 305 + flag_visokosnogo_goda;break;
					case 12:den++;if (den == 366 + flag_visokosnogo_goda) den = 335 + flag_visokosnogo_goda;break;
				}
				break;
				case 12:god--;if (god == 1999) god = 2999;break;
				case 16:
				if ((flag_timer == 0)&&(flag_signala == 0))
				{
					vremya[17]++;
					if (vremya[17] == 10)
					{
						vremya[17] = 0;
						vremya[16]++;
					}
					if ((vremya[16] == 2)&&(vremya[17] == 4))
					{
						vremya[16] = 0;
						vremya[17] = 0;
					}
				}
				break;
				case 20:break;
				case 24:break;
			}
			flag_0[1] = 0;
			proverka[1] = 0;
		}
	}
	else
	{
		if (~PINC&0b00001000)
		{
			flag_0[1] = 1;
		}
		else
		{
			flag_0[1] = 0;
			proverka[1] = 0;
		}
	}
	asm("sei");
}

/***** 3 - +1 *****/
knopka2()
{
	asm("cli");
	if (proverka[2] > 39)
	{
		if (PINC&0b00000100)
		{
			flag_0[2] = 1;
		}
		else
		{
			flag_0[2] = 0;
			proverka[2] = 40;
		}
		if (proverka[2] > 79)
		{
			switch(n)
			{
				case 0:
				if (flag_prosmotr == 0)
				{
					vremya[3]++;
					if (vremya[3] == 10)
					{
						vremya[3] = 0;
						vremya[2]++;
					}
					if (vremya[2] == 6)
					{
						vremya[2] = 0;
					}
				}
				break;
				case 4:
				vremya[7]++;
				if (vremya[7] == 10)
				{
					vremya[7] = 0;
					vremya[6]++;
				}
				if (vremya[6] == 6)
				{
					vremya[6] = 0;
				}
				break;
				case 8:
				switch (mesyac)
				{
					case 12:den = 1;break;
					case 1:den = 32;break;
					case 2:den = 60 + flag_visokosnogo_goda;break;
					case 3:den = 91 + flag_visokosnogo_goda;break;
					case 4:den = 121 + flag_visokosnogo_goda;break;
					case 5:den = 152 + flag_visokosnogo_goda;break;
					case 6:den = 182 + flag_visokosnogo_goda;break;
					case 7:den = 213 + flag_visokosnogo_goda;break;
					case 8:den = 244 + flag_visokosnogo_goda;break;
					case 9:den = 274 + flag_visokosnogo_goda;break;
					case 10:den = 305 + flag_visokosnogo_goda;break;
					case 11:den = 335 + flag_visokosnogo_goda;break;
				}
				break;
				case 12:god++;if (god == 3000) god = 2000;break;
				case 16:
				if ((flag_timer == 0)&&(flag_signala == 0))
				{
					vremya[19]++;
					if (vremya[19] == 10)
					{
						vremya[19] = 0;
						vremya[18]++;
					}
					if (vremya[18] == 6)
					{
						vremya[18] = 0;
					}
				}
				break;
				case 20:break;
				case 24:break;
			}
			flag_0[2] = 0;
			proverka[2] = 0;
		}
	}
	else
	{
		if (~PINC&0b00000100)
		{
			flag_0[2] = 1;
		}
		else
		{
			flag_0[2] = 0;
			proverka[2] = 0;
		}
	}
	asm("sei");
}

/***** 4.1( ) -      *****/
knopka3_1()
{
	asm("cli");
	if (proverka[3] > 39)
	{
		if (PINC&0b00000010)
		{
			flag_0[3] = 1;
		}
		else
		{
			flag_0[3] = 0;
			proverka[3] = 40;
		}
		if ((~PINC&0b00000010))
		{
			flag_knopki_4 = 1;
		}
		else
		{
			flag_knopki_4 = 0;
		}
		if (proverka_knopki_4 > 2999)
		{
			flag_knopki_4 = 0;
			proverka_knopki_4 = 3000;
			if (!(n == 24)&&!(flag_prosmotr == 1)&&!(n == 12)&&!(n == 8))
			{
				vremya[0+n] = 0;
				vremya[1+n] = 0;
				vremya[2+n] = 0;
				vremya[3+n] = 0;
			}
			switch (n)
			{
				case 0:if (!(flag_prosmotr == 1))
				{
					vremya[28] = 0;
					flag_sec = 0;
				}
				break;
				case 4:flag_bud_on_off = 0;flag_bud_1 = 0;bud_1 = 0;flag_bud_2 = 0;bud_2 = 0;break;
				case 8:den = 1;break;
				case 12:god = 2000;break;
				case 16:vremya_timer = 0;flag_timer = 0;flag_signala = 0;\
				vremya_signala = 0;break;
				case 20:flag_secundomera = 0;q = 0;break;
				case 24:flag_prosmotr = 1;n = 0;break;
			}
		}
		if (proverka[3] > 79)
		{
			if (!(proverka_knopki_4 == 3000))
			{
				n = n + 4;
				if (n == 28)
				{
					n = 0;
				}
			}
			if (flag_prosmotr == 1)
			{
				flag_prosmotr = 0;
				n = 24;
			}
			flag_0[3] = 0;
			proverka[3] = 0;
			flag_knopki_4 = 0;
			proverka_knopki_4 = 0;
		}
	}
	else
	{
		if (~PINC&0b00000010)
		{
			flag_0[3] = 1;
		}
		else
		{
			flag_0[3] = 0;
			proverka[3] = 0;
		}
	}
	asm("sei");
}

/***** 5 - *****/
knopka4()
{
	asm("cli");
	if (proverka[4] > 39)
	{
		if (PINC&0b00000001)
		{
			flag_0[4] = 1;
		}
		else
		{
			flag_0[4] = 0;
			proverka[4] = 40;
		}
		if (proverka[4] > 79)
		{
			switch(n)
			{
				case 0:break;
				case 4:flag_bud_on_off++;if (flag_bud_on_off == 3) flag_bud_on_off = 0;\
				flag_bud_1 = 0;bud_1 = 0;flag_bud_2 = 0;bud_2 = 0;break;
				case 8:break;
				case 12:break;
				case 16:
				if (!((vremya[16] == 0)&&(vremya[17] == 0)&&\
				(vremya[18] == 0)&&(vremya[19] == 0)&&(vremya_timer == 0)))
				{
					flag_timer ^= 1;
				}
				break;
				case 20:
				if (!((vremya[20] == 9)&&(vremya[21] == 9)&&\
				(vremya[22] == 9)&&(vremya[23] == 9)))
				{
					flag_secundomera ^= 1;
				}
				case 24:break;
			}
			flag_0[4] = 0;
			proverka[4] = 0;
		}
	}
	else
	{
		if (~PINC&0b00000001)
		{
			flag_0[4] = 1;
		}
		else
		{
			flag_0[4] = 0;
			proverka[4] = 0;
		}
	}
	asm("sei");
}

/*****  *****/
budilnik()
{
	asm("cli");
	if (!(flag_bud_on_off == 0))
	{
		PORTB |= 0b00100000;
	}
	else
	{
		PORTB &= 0b11011111;
	}
	if ((flag_bud_on_off == 1)&&(vremya[0] == vremya[4])&&(vremya[1] == vremya[5])&&\
	(vremya[2] == vremya[6])&&(vremya[3] == vremya[7])&&(vremya[28] == 0))
	{
		flag_bud_1 = 1;
	}
	if ((flag_bud_on_off == 2)&&(vremya[0] == vremya[4])&&(vremya[1] == vremya[5])&&\
	(vremya[2] == vremya[6])&&(vremya[3] == vremya[7])&&(vremya[28] == 0))
	{
		flag_bud_2 = 1;
	}
	asm("sei");
}

/*****  *****/
kalendar()
{
	if (0 == fmod(god,4))
	{
		flag_visokosnogo_goda = 1;
	}
	else
	{
		flag_visokosnogo_goda = 0;
	}
	if (den == 366 + flag_visokosnogo_goda)
	{
		den = 1;
		god++;
	}
	if (god == 3000)
	{
		god = 2000;
	}
	vremya[12] = floor(god/1000);
	vremya[13] = floor((god-vremya[12]*1000)/100);
	vremya[14] = floor((god-vremya[12]*1000-vremya[13]*100)/10);
	vremya[15] = god-vremya[12]*1000-vremya[13]*100-vremya[14]*10;
	if ((den>0)&&(den<32))//1
	{
		vremya[10] = 0;vremya[11] = 1;vremya[8] = floor(den/10);\
		vremya[9] = den-vremya[8]*10;
	}
	if ((den>31)&&(den<60+flag_visokosnogo_goda))//2
	{
		vremya[10] = 0;vremya[11] = 2;vremya[8] = floor((den-31)/10);\
		vremya[9] = den-vremya[8]*10-31;
	}
	if ((den>59+flag_visokosnogo_goda)&&(den<91+flag_visokosnogo_goda))//3
	{
		vremya[10] = 0;vremya[11] = 3;vremya[8] = floor((den-31-28-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-31-28-flag_visokosnogo_goda;
	}
	if ((den>90+flag_visokosnogo_goda)&&(den<121+flag_visokosnogo_goda))//4
	{
		vremya[10] = 0;vremya[11] = 4;vremya[8] = floor((den-90-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-90-flag_visokosnogo_goda;
	}
	if ((den>120+flag_visokosnogo_goda)&&(den<152+flag_visokosnogo_goda))//5
	{
		vremya[10] = 0;vremya[11] = 5;vremya[8] = floor((den-120-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-120-flag_visokosnogo_goda;
	}
	if ((den>151+flag_visokosnogo_goda)&&(den<182+flag_visokosnogo_goda))//6
	{
		vremya[10] = 0;vremya[11] = 6;vremya[8] = floor((den-151-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-151-flag_visokosnogo_goda;
	}
	if ((den>181+flag_visokosnogo_goda)&&(den<213+flag_visokosnogo_goda))//7
	{
		vremya[10] = 0;vremya[11] = 7;vremya[8] = floor((den-181-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-181-flag_visokosnogo_goda;
	}
	if ((den>212+flag_visokosnogo_goda)&&(den<244+flag_visokosnogo_goda))//8
	{
		vremya[10] = 0;vremya[11] = 8;vremya[8] = floor((den-212-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-212-flag_visokosnogo_goda;
	}
	if ((den>243+flag_visokosnogo_goda)&&(den<274+flag_visokosnogo_goda))//9
	{
		vremya[10] = 0;vremya[11] = 9;vremya[8] = floor((den-243-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-243-flag_visokosnogo_goda;
	}
	if ((den>273+flag_visokosnogo_goda)&&(den<305+flag_visokosnogo_goda))//10
	{
		vremya[10] = 1;vremya[11] = 0;vremya[8] = floor((den-273-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-273-flag_visokosnogo_goda;
	}
	if ((den>304+flag_visokosnogo_goda)&&(den<335+flag_visokosnogo_goda))//11
	{
		vremya[10] = 1;vremya[11] = 1;vremya[8] = floor((den-304-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-304-flag_visokosnogo_goda;
	}
	if ((den>334+flag_visokosnogo_goda)&&(den<366+flag_visokosnogo_goda))//12
	{
		vremya[10] = 1;vremya[11] = 2;vremya[8] = floor((den-334-flag_visokosnogo_goda)/10);\
		vremya[9] = den-vremya[8]*10-334-flag_visokosnogo_goda;
	}
	mesyac = vremya[10]*10+vremya[11];
}